Airwallex logo
Airwallex logoAirwallex logo

Card Transaction Events

Copy for LLMView as Markdown

A transaction event is the most granular level of the three-level transaction model (Lifecycle → Card Transaction → Transaction Event).

Each transaction event represents an individual network message or fund movement, with an immutable fund movement per event. Use transaction events when you need per-event details such as failure reasons, authorization subtypes, or individual amounts.

Event types: AUTHORIZATION, CLEARING, REVERSAL_AUTH.

Event subtypes: AUTHORIZATION, INCREMENTAL_AUTHORIZATION, VERIFICATION, REVERSAL, PARTIAL_REVERSAL, EXPIRED_AUTHORIZATION, CLEARING, PARTIAL_CLEARING, CLEARING_REVERSAL.

Data retention: Resources can be queried for a maximum of 2 years from creation.

Learn more about the transaction lifecycle .

Endpoints
GET /api/v1/issuing/card_transaction_events
GET /api/v1/issuing/card_transaction_events/{id}

Get card transaction events

GET /api/v1/issuing/card_transaction_events

Retrieve a paginated list of transaction events. Each event includes its type, subtype, process result, and per-event amounts. Use the lifecycle_id or card_transaction_id filter to trace the sequence of events within a specific lifecycle or card transaction.

Parameters
billing_currencystring

Filter by billing currency (3-letter ISO 4217 code).

card_idstring

Filter by card. Only returns transaction events associated with this card.

card_transaction_idstring

Filter by card transaction. Only returns transaction events belonging to this card transaction.

from_created_atstring

Filter for items created after this date in ISO8601 format (inclusive).

lifecycle_idstring

Filter by lifecycle. Only returns transaction events belonging to this lifecycle.

pagestring

A bookmark for use in pagination to retrieve either the next page or the previous page of results. You can fetch the value for this identifier from the response of the previous API call. To retrieve the next page of results, pass the value of page_after (if not null) from the response to a subsequent call. To retrieve the previous page of results, pass the value of page_before (if not null) from the response to a subsequent call.

page_sizeinteger

Number of related objects to be listed per page. The maximum is 100.

to_created_atstring

Filter for items created before this date in ISO8601 format (inclusive).

typestring

Filter by event type. One of AUTHORIZATION, CLEARING, or REVERSAL_AUTH.

AUTHORIZATION, CLEARING, REVERSAL_AUTH, UNKNOWN

Response body - 200 OK
itemsarray
items.acquiring_institution_identifierstring

Identifier of the acquiring institution (the merchant's bank).

items.auth_codestring

Authorization code returned for approved transactions.

items.billing_amountnumber

The amount for this event in the card's billing currency.

items.billing_currencystring

Three-letter ISO 4217 currency code for the billing amount.

items.card_idstring

Unique identifier of the card associated with this transaction event.

items.card_transaction_idstring

Unique identifier of the card transaction this event belongs to.

items.conversion_detailsobject

Currency conversion details, present when the billing currency differs from the transaction currency.

items.conversion_details.from_currencystring

The source currency of the conversion (3-letter ISO-4217 code).

items.conversion_details.ratenumber

The effective rate of fx after markup, in the from -> to direction.

items.conversion_details.to_currencystring

The target currency of the conversion (3-letter ISO-4217 code).

items.created_atstring

Date and time when the transaction event was created, in ISO 8601 format.

items.digital_wallet_tokenobject

Details of the digital wallet token used for the transaction, if applicable.

items.digital_wallet_token.idstring

Unique identifier for digital token.

items.digital_wallet_token.payment_methodstring

Payment method used. One of: APPLE_PAY, GOOGLE_PAY, CARD_ON_FILE

items.expiry_datestring

The date and time when the authorization is set to expire, in ISO 8601 format. After expiry, reserved funds are released. Note: the associated card transaction status may not update to EXPIRED immediately after this time.

items.failure_reasonstring

The reason the event was declined. Only present when process_result is DECLINED. Learn more about transaction failure reasons .

items.fee_detailsarray

Fees applied to this specific event.

items.fee_details.amountnumber

Fee amount.

items.fee_details.currencystring

Currency in which the fee is charged (3-letter ISO-4217 code).

items.fee_details.typestring

Fee type. One of: ATM_ACCESS_FEE.

items.idstring

Unique identifier of the transaction event.

items.lifecycle_idstring

Unique identifier of the lifecycle this event belongs to.

items.masked_card_numberstring

The masked primary account number (PAN) of the card.

items.merchantobject

Details about the merchant where the event originated, including enriched brand information.

items.merchant.additional_merchant_infoobject

Supplemental details providing richer context on the merchant and its brand. Learn more about merchant brand controls .

items.merchant.additional_merchant_info.merchant_brand_category_idinteger

The unique identifier associated with the merchant category.

items.merchant.additional_merchant_info.merchant_brand_idstring

The unique identifier for the merchant brand.

items.merchant.additional_merchant_info.merchant_brand_namestring

The full legal or common name of the merchant.

items.merchant.additional_merchant_info.merchant_brand_subcategory_idinteger

The unique identifier associated with the merchant's sub-category.

items.merchant.additional_merchant_info.merchant_logo_urlstring

URL of the merchant's logo for display purposes.

items.merchant.category_codestring

The Merchant Category Code (MCC).

items.merchant.citystring

The city of the merchant.

items.merchant.countrystring

The country of the merchant.

items.merchant.identifierstring

Unique identifier for the merchant.

items.merchant.namestring

The short name of the merchant.

items.merchant.postcodestring

The postal code of the merchant.

items.merchant.statestring

The state or province of the merchant.

items.network_transaction_idstring

Unique identifier assigned to the transaction by the card network.

items.pos_entry_modestring

The point-of-service entry mode indicating how the card was presented. One of: MANUAL, CREDENTIAL_ON_FILE, CONTACTLESS_CHIP, CONTACT_CHIP, or MAGSTRIPE.

items.process_resultstring

The processing outcome for this event. APPROVED or DECLINED.

items.remote_authobject

Data related to remote authentication, present when the transaction was processed via Remote Auth. Null or absent otherwise.

items.remote_auth.default_response_usedboolean

Indicates whether the fallback/default action from the remote auth configuration was applied.

items.remote_auth.duration_msinteger

Response time of remote authorization in milliseconds.

items.remote_auth.reasonstring

Reason for the remote authorization decision.

items.remote_auth.responsestring

The response status of the remote auth call. One of: AUTHORIZED, DECLINED.

items.remote_auth.timed_outboolean

Indicates whether the remote auth call timed out before a response was received.

items.retrieval_refstring

Reference number assigned by the acquiring bank, used to link related events (e.g., a clearing to its original authorization).

items.risk_detailsobject

Risk assessment details for this transaction event.

items.risk_details.risk_actions_performedarray

Risk actions performed for a card transaction, triggered by rules in our risk engine

items.risk_details.risk_factorsarray

Risk factors are conditions or variables that increase the likelihood of fraud or financial irregularities, assessed by our risk management system to determine the threat level of a transaction

items.risk_details.three_dsecure_outcomestring

The outcome of a 3D Secure authentication process, which verifies the identity of a cardholder during an online purchase. Can be one of: ATTEMPTED, AUTHENTICATED, FAILED, NOT_APPLICABLE, NOT_REQUESTED. Learn more about 3D Secure

items.subtypestring

A more specific classification of the event type. One of: AUTHORIZATION, INCREMENTAL_AUTHORIZATION, VERIFICATION, REVERSAL, PARTIAL_REVERSAL, EXPIRED_AUTHORIZATION, CLEARING, PARTIAL_CLEARING, CLEARING_REVERSAL.

items.transaction_amountnumber

The amount for this event in the merchant's transaction currency.

items.transaction_categorystring

The category of the transaction, derived from the card scheme's processing code. One of: PURCHASE, CASH_DISBURSEMENT, ACCOUNT_FUNDING, QUASI_CASH, MERCHANT_CREDIT, DISPUTE_CREDIT, ORIGINAL_CREDIT, ELIGIBILITY_INQUIRY, BILL_PAYMENT.

items.transaction_currencystring

Three-letter ISO 4217 currency code for the transaction amount.

items.transaction_date_timestring

The date and time the transaction occurred as reported by the card network, in ISO 8601 format.

items.typestring

The type of this transaction event. One of: AUTHORIZATION, CLEARING, or REVERSAL_AUTH.

items.updated_atstring

Date and time when the transaction event was last updated, in ISO 8601 format.

page_afterstring

A marker for retrieving the next page of results. Include this value in the page request parameter to retrieve subsequent pages.

page_beforestring

A marker for retrieving the previous page of results. Include this value in the page request parameter to retrieve previous pages.

Errors
Error statusDescription
400

Possible errors: field_required, bad_request, invalid_argument

401

Possible errors: credentials_invalid, credentials_expired

429

Too many requests

500

Service unavailable

GET /api/v1/issuing/card_transaction_events
$curl --request GET \
> --url 'https://api-demo.airwallex.com/api/v1/issuing/card_transaction_events' \
> --header 'Authorization: Bearer {{ACCESS_TOKEN}}' \
> --header 'Content-Type: application/json'
Response (200 OK)
1{
2 "items": [
3 {
4 "acquiring_institution_identifier": "410964",
5 "auth_code": "VJT90Z",
6 "billing_amount": 100,
7 "billing_currency": "USD",
8 "card_transaction_id": "5b2dc266-09ad-4235-b61a-767c7cd6d6ef",
9 "conversion_details": {
10 "from_currency": "USD",
11 "rate": 1.56,
12 "to_currency": "AUD"
13 },
14 "created_at": "2018-03-22T16:08:02+00:00",
15 "digital_wallet_token": {
16 "id": "6c2dc266-09ad-4235-b61a-767c7cd6d6ea",
17 "payment_method": "GOOGLE_PAY"
18 },
19 "expiry_date": "2026-02-01T16:08:02+00:00",
20 "fee_details": [
21 {
22 "amount": 500,
23 "currency": "USD",
24 "type": "ATM_ACCESS_FEE"
25 }
26 ],
27 "id": "7f687fe6-dcf4-4462-92fa-80335301d9d2",
28 "lifecycle_id": "6c2dc266-09ad-4235-b61a-767c7cd6d6ea",
29 "masked_card_number": "************4242",
30 "merchant": {
31 "additional_merchant_info": {
32 "merchant_brand_category_id": 17000,
33 "merchant_brand_id": "6c2dc266-09ad-4235-b61a-767c7cd6d6ea",
34 "merchant_brand_name": "Meta",
35 "merchant_brand_subcategory_id": 17004,
36 "merchant_logo_url": "https://example.com/logo.png"
37 },
38 "category_code": "4829",
39 "city": "New York",
40 "country": "US",
41 "identifier": "012345678910123",
42 "name": "Test Merchant",
43 "postcode": "10001",
44 "state": "NY"
45 },
46 "network_transaction_id": "386055120641953",
47 "pos_entry_mode": "CONTACTLESS_CHIP",
48 "process_result": "APPROVED",
49 "retrieval_ref": "605103644028",
50 "risk_details": {
51 "risk_actions_performed": [
52 "TRANSACTION_BLOCKED"
53 ],
54 "risk_factors": [
55 "Suspicious transaction velocity"
56 ],
57 "three_dsecure_outcome": "AUTHENTICATED"
58 },
59 "subtype": "AUTHORIZATION",
60 "transaction_amount": 100,
61 "transaction_category": "PURCHASE",
62 "transaction_currency": "AUD",
63 "transaction_date_time": "2018-03-22T16:08:02+00:00",
64 "type": "AUTHORIZATION",
65 "updated_at": "2018-03-22T16:08:02+00:00"
66 }
67 ],
68 "page_after": "YWZ0ZXI9MmFjNmEzMjQtM2IwNC00M2JkLThmNTUtOWQ5YzdmZjEzZGZm",
69 "page_before": "YmVmb3JlPWVmZDQxZTk3LTU2MzctNDQ5MC04NjNkLTU2MDE5MjIwNDQ2YQ=="
70}
Was this section helpful?

Get single card transaction event

GET /api/v1/issuing/card_transaction_events/{id}

Retrieve a single transaction event by its unique identifier. The response includes the event type, subtype, process result, failure reason (if declined), and per-event billing and transaction amounts.

Parameters
idrequiredstring

Unique identifier of the transaction event.

Response body - 200 OK
acquiring_institution_identifierstring

Identifier of the acquiring institution (the merchant's bank).

auth_codestring

Authorization code returned for approved transactions.

billing_amountnumber

The amount for this event in the card's billing currency.

billing_currencystring

Three-letter ISO 4217 currency code for the billing amount.

card_idstring

Unique identifier of the card associated with this transaction event.

card_transaction_idstring

Unique identifier of the card transaction this event belongs to.

conversion_detailsobject

Currency conversion details, present when the billing currency differs from the transaction currency.

conversion_details.from_currencystring

The source currency of the conversion (3-letter ISO-4217 code).

conversion_details.ratenumber

The effective rate of fx after markup, in the from -> to direction.

conversion_details.to_currencystring

The target currency of the conversion (3-letter ISO-4217 code).

created_atstring

Date and time when the transaction event was created, in ISO 8601 format.

digital_wallet_tokenobject

Details of the digital wallet token used for the transaction, if applicable.

digital_wallet_token.idstring

Unique identifier for digital token.

digital_wallet_token.payment_methodstring

Payment method used. One of: APPLE_PAY, GOOGLE_PAY, CARD_ON_FILE

expiry_datestring

The date and time when the authorization is set to expire, in ISO 8601 format. After expiry, reserved funds are released. Note: the associated card transaction status may not update to EXPIRED immediately after this time.

failure_reasonstring

The reason the event was declined. Only present when process_result is DECLINED. Learn more about transaction failure reasons .

fee_detailsarray

Fees applied to this specific event.

fee_details.amountnumber

Fee amount.

fee_details.currencystring

Currency in which the fee is charged (3-letter ISO-4217 code).

fee_details.typestring

Fee type. One of: ATM_ACCESS_FEE.

idstring

Unique identifier of the transaction event.

lifecycle_idstring

Unique identifier of the lifecycle this event belongs to.

masked_card_numberstring

The masked primary account number (PAN) of the card.

merchantobject

Details about the merchant where the event originated, including enriched brand information.

merchant.additional_merchant_infoobject

Supplemental details providing richer context on the merchant and its brand. Learn more about merchant brand controls .

merchant.additional_merchant_info.merchant_brand_category_idinteger

The unique identifier associated with the merchant category.

merchant.additional_merchant_info.merchant_brand_idstring

The unique identifier for the merchant brand.

merchant.additional_merchant_info.merchant_brand_namestring

The full legal or common name of the merchant.

merchant.additional_merchant_info.merchant_brand_subcategory_idinteger

The unique identifier associated with the merchant's sub-category.

merchant.additional_merchant_info.merchant_logo_urlstring

URL of the merchant's logo for display purposes.

merchant.category_codestring

The Merchant Category Code (MCC).

merchant.citystring

The city of the merchant.

merchant.countrystring

The country of the merchant.

merchant.identifierstring

Unique identifier for the merchant.

merchant.namestring

The short name of the merchant.

merchant.postcodestring

The postal code of the merchant.

merchant.statestring

The state or province of the merchant.

network_transaction_idstring

Unique identifier assigned to the transaction by the card network.

pos_entry_modestring

The point-of-service entry mode indicating how the card was presented. One of: MANUAL, CREDENTIAL_ON_FILE, CONTACTLESS_CHIP, CONTACT_CHIP, or MAGSTRIPE.

process_resultstring

The processing outcome for this event. APPROVED or DECLINED.

remote_authobject

Data related to remote authentication, present when the transaction was processed via Remote Auth. Null or absent otherwise.

remote_auth.default_response_usedboolean

Indicates whether the fallback/default action from the remote auth configuration was applied.

remote_auth.duration_msinteger

Response time of remote authorization in milliseconds.

remote_auth.reasonstring

Reason for the remote authorization decision.

remote_auth.responsestring

The response status of the remote auth call. One of: AUTHORIZED, DECLINED.

remote_auth.timed_outboolean

Indicates whether the remote auth call timed out before a response was received.

retrieval_refstring

Reference number assigned by the acquiring bank, used to link related events (e.g., a clearing to its original authorization).

risk_detailsobject

Risk assessment details for this transaction event.

risk_details.risk_actions_performedarray

Risk actions performed for a card transaction, triggered by rules in our risk engine

risk_details.risk_factorsarray

Risk factors are conditions or variables that increase the likelihood of fraud or financial irregularities, assessed by our risk management system to determine the threat level of a transaction

risk_details.three_dsecure_outcomestring

The outcome of a 3D Secure authentication process, which verifies the identity of a cardholder during an online purchase. Can be one of: ATTEMPTED, AUTHENTICATED, FAILED, NOT_APPLICABLE, NOT_REQUESTED. Learn more about 3D Secure

subtypestring

A more specific classification of the event type. One of: AUTHORIZATION, INCREMENTAL_AUTHORIZATION, VERIFICATION, REVERSAL, PARTIAL_REVERSAL, EXPIRED_AUTHORIZATION, CLEARING, PARTIAL_CLEARING, CLEARING_REVERSAL.

transaction_amountnumber

The amount for this event in the merchant's transaction currency.

transaction_categorystring

The category of the transaction, derived from the card scheme's processing code. One of: PURCHASE, CASH_DISBURSEMENT, ACCOUNT_FUNDING, QUASI_CASH, MERCHANT_CREDIT, DISPUTE_CREDIT, ORIGINAL_CREDIT, ELIGIBILITY_INQUIRY, BILL_PAYMENT.

transaction_currencystring

Three-letter ISO 4217 currency code for the transaction amount.

transaction_date_timestring

The date and time the transaction occurred as reported by the card network, in ISO 8601 format.

typestring

The type of this transaction event. One of: AUTHORIZATION, CLEARING, or REVERSAL_AUTH.

updated_atstring

Date and time when the transaction event was last updated, in ISO 8601 format.

Errors
Error statusDescription
400

Possible errors: field_required, bad_request, invalid_argument

401

Possible errors: credentials_invalid, credentials_expired

429

Too many requests

500

Service unavailable

GET /api/v1/issuing/card_transaction_events/{id}
$curl --request GET \
> --url 'https://api-demo.airwallex.com/api/v1/issuing/card_transaction_events/card_transaction_event_id' \
> --header 'Authorization: Bearer {{ACCESS_TOKEN}}' \
> --header 'Content-Type: application/json'
Response (200 OK)
1{
2 "acquiring_institution_identifier": "410964",
3 "auth_code": "VJT90Z",
4 "billing_amount": 100,
5 "billing_currency": "USD",
6 "card_transaction_id": "5b2dc266-09ad-4235-b61a-767c7cd6d6ef",
7 "conversion_details": {
8 "from_currency": "USD",
9 "rate": 1.56,
10 "to_currency": "AUD"
11 },
12 "created_at": "2018-03-22T16:08:02+00:00",
13 "digital_wallet_token": {
14 "id": "6c2dc266-09ad-4235-b61a-767c7cd6d6ea",
15 "payment_method": "GOOGLE_PAY"
16 },
17 "expiry_date": "2026-02-01T16:08:02+00:00",
18 "failure_reason": "<string>",
19 "fee_details": [
20 {
21 "amount": 500,
22 "currency": "USD",
23 "type": "ATM_ACCESS_FEE"
24 }
25 ],
26 "id": "7f687fe6-dcf4-4462-92fa-80335301d9d2",
27 "lifecycle_id": "6c2dc266-09ad-4235-b61a-767c7cd6d6ea",
28 "masked_card_number": "************4242",
29 "merchant": {
30 "additional_merchant_info": {
31 "merchant_brand_category_id": 17000,
32 "merchant_brand_id": "6c2dc266-09ad-4235-b61a-767c7cd6d6ea",
33 "merchant_brand_name": "Meta",
34 "merchant_brand_subcategory_id": 17004,
35 "merchant_logo_url": "https://example.com/logo.png"
36 },
37 "category_code": "4829",
38 "city": "New York",
39 "country": "US",
40 "identifier": "012345678910123",
41 "name": "Test Merchant",
42 "postcode": "10001",
43 "state": "NY"
44 },
45 "network_transaction_id": "386055120641953",
46 "pos_entry_mode": "CONTACTLESS_CHIP",
47 "process_result": "APPROVED",
48 "retrieval_ref": "605103644028",
49 "risk_details": {
50 "risk_actions_performed": [
51 "TRANSACTION_BLOCKED"
52 ],
53 "risk_factors": [
54 "Suspicious transaction velocity"
55 ],
56 "three_dsecure_outcome": "AUTHENTICATED"
57 },
58 "subtype": "AUTHORIZATION",
59 "transaction_amount": 100,
60 "transaction_category": "PURCHASE",
61 "transaction_currency": "AUD",
62 "transaction_date_time": "2018-03-22T16:08:02+00:00",
63 "type": "AUTHORIZATION",
64 "updated_at": "2018-03-22T16:08:02+00:00"
65}
Was this section helpful?